diff --git a/ui/include/classes/api/services/CUserDirectory.php b/ui/include/classes/api/services/CUserDirectory.php
new file mode 100644
index 00000000000..71eddb21976
--- /dev/null
+++ b/ui/include/classes/api/services/CUserDirectory.php
@@ -0,0 +1,481 @@
+<?php declare(strict_types = 1);
+/*
+** Zabbix
+** Copyright (C) 2001-2022 Zabbix SIA
+**
+** This program is free software; you can redistribute it and/or modify
+** it under the terms of the GNU General Public License as published by
+** the Free Software Foundation; either version 2 of the License, or
+** (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+** GNU General Public License for more details.
+**
+** You should have received a copy of the GNU General Public License
+** along with this program; if not, write to the Free Software
+** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+**/
+
+
+class CUserDirectory extends CApiService {
+
+	public const ACCESS_RULES = [
+		'get' => ['min_user_type' => USER_TYPE_SUPER_ADMIN],
+		'create' => ['min_user_type' => USER_TYPE_SUPER_ADMIN],
+		'update' => ['min_user_type' => USER_TYPE_SUPER_ADMIN],
+		'delete' => ['min_user_type' => USER_TYPE_SUPER_ADMIN],
+		'test' => ['min_user_type' => USER_TYPE_SUPER_ADMIN]
+	];
+
+	protected $tableName = 'userdirectory';
+	protected $tableAlias = 'ud';
+	protected $sortColumns = ['host', 'name'];
+
+	/**
+	 * @var array
+	 */
+	protected $output_fields = ['userdirectoryid', 'name', 'description', 'host', 'port', 'base_dn', 'bind_dn',
+		'search_attribute', 'start_tls', 'search_filter'
+	];
+
+	/**
+	 * @param array $options
+	 *
+	 * @throws APIException
+	 *
+	 * @return array|string
+	 */
+	public function get(array $options) {
+		$api_input_rules = ['type' => API_OBJECT, 'fields' => [
+			// filter
+			'userdirectoryids' =>			['type' => API_IDS, 'flags' => API_ALLOW_NULL | API_NORMALIZE, 'default' => null],
+			'filter' =>						['type' => API_OBJECT, 'flags' => API_ALLOW_NULL, 'default' => null, 'fields' => [
+				'userdirectoryid' =>			['type' => API_IDS, 'flags' => API_ALLOW_NULL | API_NORMALIZE],
+				'host' =>						['type' => API_STRINGS_UTF8, 'flags' => API_ALLOW_NULL | API_NORMALIZE],
+				'name' =>						['type' => API_STRINGS_UTF8, 'flags' => API_ALLOW_NULL | API_NORMALIZE]
+			]],
+			'search' =>						['type' => API_OBJECT, 'flags' => API_ALLOW_NULL, 'default' => null, 'fields' => array_fill_keys(
+				['base_dn', 'bind_dn', 'description', 'host', 'name', 'search_attribute', 'search_filter'],
+				['type' => API_STRINGS_UTF8, 'flags' => API_ALLOW_NULL | API_NORMALIZE]
+			)],
+			'searchByAny' =>				['type' => API_BOOLEAN, 'default' => false],
+			'startSearch' =>				['type' => API_FLAG, 'default' => false],
+			'excludeSearch' =>				['type' => API_FLAG, 'default' => false],
+			'searchWildcardsEnabled' =>		['type' => API_BOOLEAN, 'default' => false],
+			// output
+			'output' =>						['type' => API_OUTPUT, 'in' => implode(',', $this->output_fields), 'default' => API_OUTPUT_EXTEND],
+			'countOutput' =>				['type' => API_FLAG, 'default' => false],
+			'selectUsrgrps' =>				['type' => API_OUTPUT, 'flags' => API_ALLOW_NULL | API_ALLOW_COUNT, 'in' => implode(',', ['usrgrpid', 'name', 'gui_access', 'users_status', 'debug_mode']), 'default' => null],
+			// sort and limit
+			'sortfield' =>					['type' => API_STRINGS_UTF8, 'flags' => API_NORMALIZE, 'in' => implode(',', $this->sortColumns), 'uniq' => true, 'default' => []],
+			'sortorder' =>					['type' => API_SORTORDER, 'default' => []],
+			'limit' =>						['type' => API_INT32, 'flags' => API_ALLOW_NULL, 'in' => '1:'.ZBX_MAX_INT32, 'default' => null],
+			// flags
+			'preservekeys' =>				['type' => API_BOOLEAN, 'default' => false],
+		]];
+
+		if (!CApiInputValidator::validate($api_input_rules, $options, '/', $error)) {
+			self::exception(ZBX_API_ERROR_PARAMETERS, $error);
+		}
+
+		if ($options['output'] === API_OUTPUT_EXTEND) {
+			$options['output'] = $this->output_fields;
+		}
+
+		$db_userdirectories = [];
+
+		$sql = $this->createSelectQuery($this->tableName, $options);
+		$resource = DBselect($sql, $options['limit']);
+
+		while ($row = DBfetch($resource)) {
+			if ($options['countOutput']) {
+				return $row['rowscount'];
+			}
+
+			$db_userdirectories[$row['userdirectoryid']] = $row;
+		}
+
+		if ($db_userdirectories) {
+			$db_userdirectories = $this->addRelatedObjects($options, $db_userdirectories);
+			$db_userdirectories = $this->unsetExtraFields($db_userdirectories, ['userdirectoryid'], $options['output']);
+
+			if (!$options['preservekeys']) {
+				$db_userdirectories = array_values($db_userdirectories);
+			}
+		}
+
+		return $db_userdirectories;
+	}
+
+	/**
+	 * @param array $options
+	 * @param array $result
+	 *
+	 * @return array
+	 */
+	protected function addRelatedObjects(array $options, array $result): array {
+		$result = parent::addRelatedObjects($options, $result);
+
+		self::addRelatedUserGroups($options, $result);
+
+		return $result;
+	}
+
+	/**
+	 * @param array $options
+	 * @param array $result
+	 */
+	private static function addRelatedUserGroups(array $options, array &$result): void {
+		if ($options['selectUsrgrps'] === null) {
+			return;
+		}
+
+		foreach ($result as &$row) {
+			$row['usrgrps'] = [];
+		}
+		unset($row);
+
+		if ($options['selectUsrgrps'] === API_OUTPUT_COUNT) {
+			$output = ['userdirectoryid'];
+		}
+		elseif ($options['selectUsrgrps'] === API_OUTPUT_EXTEND) {
+			$output = ['usrgrpid', 'name', 'gui_access', 'users_status', 'debug_mode', 'userdirectoryid'];
+		}
+		else {
+			$output = array_unique(array_merge(['userdirectoryid'], $options['selectUsrgrps']));
+		}
+
+		$db_usergroups = API::UserGroup()->get([
+			'output' => $output,
+			'filter' => ['userdirectoryid' => array_keys($result)]
+		]);
+
+		foreach ($db_usergroups as $db_usergroup) {
+			$result[$db_usergroup['userdirectoryid']]['usrgrps'][] =
+				array_diff_key($db_usergroup, array_flip(['userdirectoryid']));
+		}
+
+		if ($options['selectUsrgrps'] === API_OUTPUT_COUNT) {
+			foreach ($result as &$row) {
+				$row['usrgrps'] = (string) count($row['usrgrps']);
+			}
+			unset($row);
+		}
+	}
+
+	/**
+	 * @param array $userdirectories
+	 *
+	 * @throws APIException
+	 *
+	 * @return array
+	 */
+	public function create(array $userdirectories): array {
+		self::validateCreate($userdirectories);
+
+		$db_count = DB::select('userdirectory', ['countOutput' => true]);
+		$userdirectoryids = DB::insert('userdirectory', $userdirectories);
+
+		foreach ($userdirectories as $index => &$userdirectory) {
+			$userdirectory['userdirectoryid'] = $userdirectoryids[$index];
+		}
+		unset($userdirectory);
+
+		self::addAuditLog(CAudit::ACTION_ADD, CAudit::RESOURCE_USERDIRECTORY, $userdirectories);
+
+		if (!$db_count) {
+			API::Authentication()->update(['ldap_userdirectoryid' => reset($userdirectoryids)]);
+		}
+
+		return ['userdirectoryids' => $userdirectoryids];
+	}
+
+	/**
+	 * @param array $userdirectories
+	 *
+	 * @throws APIException
+	 */
+	private static function validateCreate(array &$userdirectories): void {
+		$api_input_rules = ['type' => API_OBJECTS, 'flags' => API_NOT_EMPTY | API_NORMALIZE, 'uniq' => [['name']], 'fields' => [
+			'name' =>				['type' => API_STRING_UTF8, 'flags' => API_REQUIRED | API_NOT_EMPTY, 'length' => DB::getFieldLength('userdirectory', 'name')],
+			'description' =>		['type' => API_STRING_UTF8, 'length' => DB::getFieldLength('userdirectory', 'description')],
+			'host' =>				['type' => API_STRING_UTF8, 'flags' => API_REQUIRED | API_NOT_EMPTY, 'length' => DB::getFieldLength('userdirectory', 'host')],
+			'port' =>				['type' => API_PORT, 'flags' => API_REQUIRED | API_NOT_EMPTY],
+			'base_dn' =>			['type' => API_STRING_UTF8, 'flags' => API_REQUIRED | API_NOT_EMPTY, 'length' => DB::getFieldLength('userdirectory', 'base_dn')],
+			'bind_dn' =>			['type' => API_STRING_UTF8, 'length' => DB::getFieldLength('userdirectory', 'bind_dn')],
+			'bind_password' =>		['type' => API_STRING_UTF8, 'length' => DB::getFieldLength('userdirectory', 'bind_password')],
+			'search_attribute' =>	['type' => API_STRING_UTF8, 'flags' => API_REQUIRED | API_NOT_EMPTY, 'length' => DB::getFieldLength('userdirectory', 'search_attribute')],
+			'start_tls' =>			['type' => API_INT32, 'in' => ZBX_AUTH_START_TLS_OFF.','.ZBX_AUTH_START_TLS_ON],
+			'search_filter' =>		['type' => API_STRING_UTF8, 'length' => DB::getFieldLength('userdirectory', 'search_filter')]
+		]];
+
+		if (!CApiInputValidator::validate($api_input_rules, $userdirectories, '/', $error)) {
+			self::exception(ZBX_API_ERROR_PARAMETERS, $error);
+		}
+
+		self::checkDuplicates($userdirectories);
+	}
+
+	/**
+	 * @param array $userdirectories
+	 *
+	 * @throws APIException
+	 *
+	 * @return array
+	 */
+	public function update(array $userdirectories): array {
+		self::validateUpdate($userdirectories, $db_userdirectories);
+
+		$upd_userdirectories = [];
+
+		foreach ($userdirectories as $userdirectory) {
+			$upd_userdirectory = DB::getUpdatedValues('userdirectory', $userdirectory,
+				$db_userdirectories[$userdirectory['userdirectoryid']]
+			);
+
+			if ($upd_userdirectory) {
+				$upd_userdirectories[] = [
+					'values' => $upd_userdirectory,
+					'where' => ['userdirectoryid' => $userdirectory['userdirectoryid']]
+				];
+			}
+		}
+
+		if ($upd_userdirectories) {
+			DB::update('userdirectory', $upd_userdirectories);
+
+			self::addAuditLog(CAudit::ACTION_UPDATE, CAudit::RESOURCE_USERDIRECTORY, $userdirectories,
+				$db_userdirectories
+			);
+		}
+
+		return ['userdirectoryids' => array_column($userdirectories, 'userdirectoryid')];
+	}
+
+	/**
+	 * @param array      $userdirectories
+	 * @param array|null $db_userdirectories
+	 *
+	 * @throws APIException
+	 */
+	private static function validateUpdate(array &$userdirectories, ?array &$db_userdirectories): void {
+		$api_input_rules = ['type' => API_OBJECTS, 'flags' => API_NOT_EMPTY | API_NORMALIZE, 'uniq' => [['userdirectoryid'], ['name']], 'fields' => [
+			'userdirectoryid' =>	['type' => API_ID, 'flags' => API_REQUIRED],
+			'name' =>				['type' => API_STRING_UTF8, 'flags' => API_NOT_EMPTY, 'length' => DB::getFieldLength('userdirectory', 'name')],
+			'description' =>		['type' => API_STRING_UTF8, 'length' => DB::getFieldLength('userdirectory', 'description')],
+			'host' =>				['type' => API_STRING_UTF8, 'flags' => API_NOT_EMPTY, 'length' => DB::getFieldLength('userdirectory', 'host')],
+			'port' =>				['type' => API_PORT, 'flags' => API_NOT_EMPTY],
+			'base_dn' =>			['type' => API_STRING_UTF8, 'flags' => API_NOT_EMPTY, 'length' => DB::getFieldLength('userdirectory', 'base_dn')],
+			'bind_dn' =>			['type' => API_STRING_UTF8, 'length' => DB::getFieldLength('userdirectory', 'bind_dn')],
+			'bind_password' =>		['type' => API_STRING_UTF8, 'length' => DB::getFieldLength('userdirectory', 'bind_password')],
+			'search_attribute' =>	['type' => API_STRING_UTF8, 'flags' => API_NOT_EMPTY, 'length' => DB::getFieldLength('userdirectory', 'search_attribute')],
+			'start_tls' =>			['type' => API_INT32, 'in' => ZBX_AUTH_START_TLS_OFF.','.ZBX_AUTH_START_TLS_ON],
+			'search_filter' =>		['type' => API_STRING_UTF8, 'length' => DB::getFieldLength('userdirectory', 'search_filter')]
+		]];
+
+		if (!CApiInputValidator::validate($api_input_rules, $userdirectories, '/', $error)) {
+			self::exception(ZBX_API_ERROR_PARAMETERS, $error);
+		}
+
+		$db_userdirectories = DB::select('userdirectory', [
+			'output' => ['userdirectoryid', 'name', 'description', 'host', 'port', 'base_dn', 'bind_dn',
+				'bind_password', 'search_attribute', 'start_tls', 'search_filter'
+			],
+			'userdirectoryids' => array_column($userdirectories, 'userdirectoryid'),
+			'preservekeys' => true
+		]);
+
+		if (count($db_userdirectories) != count($userdirectories)) {
+			self::exception(ZBX_API_ERROR_PERMISSIONS, _('No permissions to referred object or it does not exist!'));
+		}
+
+		self::checkDuplicates($userdirectories, $db_userdirectories);
+	}
+
+	/**
+	 * Check for unique names.
+	 *
+	 * @param array      $userdirectories
+	 * @param array|null $db_userdirectories
+	 *
+	 * @throws APIException if userdirectory name is not unique.
+	 */
+	private static function checkDuplicates(array $userdirectories, array $db_userdirectories = null): void {
+		$names = [];
+
+		foreach ($userdirectories as $userdirectory) {
+			if (!array_key_exists('name', $userdirectory)) {
+				continue;
+			}
+
+			if ($db_userdirectories === null
+					|| $userdirectory['name'] !== $db_userdirectories[$userdirectory['userdirectoryid']]['name']) {
+				$names[] = $userdirectory['name'];
+			}
+		}
+
+		if (!$names) {
+			return;
+		}
+
+		$duplicates = DB::select('userdirectory', [
+			'output' => ['name'],
+			'filter' => ['name' => $names],
+			'limit' => 1
+		]);
+
+		if ($duplicates) {
+			self::exception(ZBX_API_ERROR_PARAMETERS, _s('User directory "%1$s" already exists.',
+				$duplicates[0]['name'])
+			);
+		}
+	}
+
+	/**
+	 * @param array $userdirectoryids
+	 *
+	 * @throws APIException
+	 *
+	 * @return array
+	 */
+	public function delete(array $userdirectoryids): array {
+		self::validateDelete($userdirectoryids, $db_userdirectories);
+
+		DB::delete('userdirectory', ['userdirectoryid' => $userdirectoryids]);
+
+		self::addAuditLog(CAudit::ACTION_DELETE, CAudit::RESOURCE_USERDIRECTORY, $db_userdirectories);
+
+		return ['userdirectoryids' => $userdirectoryids];
+	}
+
+	/**
+	 * @param array      $userdirectoryids
+	 * @param array|null $db_userdirectories
+	 *
+	 * @throws APIException
+	 */
+	private static function validateDelete(array $userdirectoryids, ?array &$db_userdirectories): void {
+		$api_input_rules = ['type' => API_IDS, 'flags' => API_NOT_EMPTY, 'uniq' => true];
+
+		if (!CApiInputValidator::validate($api_input_rules, $userdirectoryids, '/', $error)) {
+			self::exception(ZBX_API_ERROR_PARAMETERS, $error);
+		}
+
+		$db_userdirectories = API::UserDirectory()->get([
+			'output' => ['userdirectoryid', 'name'],
+			'userdirectoryids' => $userdirectoryids,
+			'preservekeys' => true
+		]);
+
+		if (count($db_userdirectories) != count($userdirectoryids)) {
+			self::exception(ZBX_API_ERROR_PERMISSIONS, _('No permissions to referred object or it does not exist!'));
+		}
+
+		$userdirectories_left = API::UserDirectory()->get(['countOutput' => true]) - count($userdirectoryids);
+		$auth = API::Authentication()->get([
+			'output' => ['ldap_userdirectoryid', 'authentication_type', 'ldap_configured']
+		]);
+
+		if (in_array($auth['ldap_userdirectoryid'], $userdirectoryids)
+				&& ($auth['ldap_configured'] == ZBX_AUTH_LDAP_ENABLED || $userdirectories_left > 0)) {
+			self::exception(ZBX_API_ERROR_PARAMETERS, _('Cannot delete default user directory.'));
+		}
+
+		$db_groups = API::UserGroup()->get([
+			'output' => ['userdirectoryid'],
+			'filter' => [
+				'gui_access' => [GROUP_GUI_ACCESS_LDAP, GROUP_GUI_ACCESS_SYSTEM],
+				'userdirectoryid' => $userdirectoryids
+			],
+			'limit' => 1
+		]);
+
+		if ($db_groups) {
+			$db_group = reset($db_groups);
+
+			self::exception(ZBX_API_ERROR_PARAMETERS, _s('Cannot delete user directory "%1$s".',
+				$db_userdirectories[$db_group['userdirectoryid']]['name'])
+			);
+		}
+
+		if (in_array($auth['ldap_userdirectoryid'], $userdirectoryids)) {
+			// If last (default) is removed, reset default userdirectoryid to prevent from foreign key constraint.
+			API::Authentication()->update(['ldap_userdirectoryid' => 0]);
+		}
+	}
+
+	/**
+	 * Test user against specific userdirectory connection.
+	 *
+	 * @param array $userdirectory
+	 *
+	 * @throws APIException
+	 *
+	 * @return bool
+	 */
+	public function test(array $userdirectory): bool {
+		self::validateTest($userdirectory);
+
+		$user = [
+			'username' => $userdirectory['test_username'],
+			'password' => $userdirectory['test_password']
+		];
+		$ldap_validator = new CLdapAuthValidator(['conf' => $userdirectory]);
+
+		if (!$ldap_validator->validate($user)) {
+			self::exception(
+				$ldap_validator->isConnectionError() ? ZBX_API_ERROR_PARAMETERS : ZBX_API_ERROR_PERMISSIONS,
+				$ldap_validator->getError()
+			);
+		}
+
+		return true;
+	}
+
+	/**
+	 * Validate user directory and test user credentials to be used for testing.
+	 *
+	 * @param array $userdirectory
+	 *
+	 * @throws APIException
+	 */
+	protected static function validateTest(array &$userdirectory): void {
+		$api_input_rules = ['type' => API_OBJECT, 'flags' => API_NOT_EMPTY | API_NORMALIZE, 'fields' => [
+			'userdirectoryid' =>	['type' => API_ID, 'flags' => API_ALLOW_NULL, 'default' => null],
+			'host' =>				['type' => API_STRING_UTF8, 'flags' => API_REQUIRED | API_NOT_EMPTY, 'length' => DB::getFieldLength('userdirectory', 'host')],
+			'port' =>				['type' => API_PORT, 'flags' => API_REQUIRED | API_NOT_EMPTY],
+			'base_dn' =>			['type' => API_STRING_UTF8, 'flags' => API_REQUIRED | API_NOT_EMPTY, 'length' => DB::getFieldLength('userdirectory', 'base_dn')],
+			'bind_dn' =>			['type' => API_STRING_UTF8, 'length' => DB::getFieldLength('userdirectory', 'bind_dn'), 'default' => ''],
+			'bind_password' =>		['type' => API_STRING_UTF8, 'length' => DB::getFieldLength('userdirectory', 'bind_password')],
+			'search_attribute' =>	['type' => API_STRING_UTF8, 'flags' => API_REQUIRED | API_NOT_EMPTY, 'length' => DB::getFieldLength('userdirectory', 'search_attribute')],
+			'start_tls' =>			['type' => API_INT32, 'in' => ZBX_AUTH_START_TLS_OFF.','.ZBX_AUTH_START_TLS_ON, 'default' => ZBX_AUTH_START_TLS_OFF],
+			'search_filter' =>		['type' => API_STRING_UTF8, 'length' => DB::getFieldLength('userdirectory', 'search_filter'), 'default' => ''],
+			'test_username' =>		['type' => API_STRING_UTF8, 'flags' => API_REQUIRED | API_NOT_EMPTY],
+			'test_password' =>		['type' => API_STRING_UTF8, 'flags' => API_REQUIRED | API_NOT_EMPTY]
+		]];
+
+		if (!CApiInputValidator::validate($api_input_rules, $userdirectory, '/', $error)) {
+			self::exception(ZBX_API_ERROR_PARAMETERS, $error);
+		}
+
+		if ($userdirectory['userdirectoryid'] !== null) {
+			$db_userdirectory = DB::select('userdirectory', [
+				'output' => ['host', 'port', 'base_dn', 'bind_dn', 'bind_password', 'search_attribute', 'start_tls',
+					'search_filter'
+				],
+				'userdirectoryids' => $userdirectory['userdirectoryid']
+			]);
+			$db_userdirectory = reset($db_userdirectory);
+
+			if (!$db_userdirectory) {
+				self::exception(ZBX_API_ERROR_PERMISSIONS,
+					_('No permissions to referred object or it does not exist!')
+				);
+			}
+
+			$userdirectory += $db_userdirectory;
+		}
+	}
+}
diff --git a/ui/include/classes/api/services/CUserGroup.php b/ui/include/classes/api/services/CUserGroup.php
index 9bb5979dc11..c0d72cfac85 100644
--- a/ui/include/classes/api/services/CUserGroup.php
+++ b/ui/include/classes/api/services/CUserGroup.php
@@ -208,22 +208,26 @@ class CUserGroup extends CApiService {
 	 */
 	private function validateCreate(array &$usrgrps) {
 		$api_input_rules = ['type' => API_OBJECTS, 'flags' => API_NOT_EMPTY | API_NORMALIZE, 'uniq' => [['name']], 'fields' => [
-			'name' =>			['type' => API_STRING_UTF8, 'flags' => API_REQUIRED | API_NOT_EMPTY, 'length' => DB::getFieldLength('usrgrp', 'name')],
-			'debug_mode' =>		['type' => API_INT32, 'in' => implode(',', [GROUP_DEBUG_MODE_DISABLED, GROUP_DEBUG_MODE_ENABLED])],
-			'gui_access' =>		['type' => API_INT32, 'in' => implode(',', [GROUP_GUI_ACCESS_SYSTEM, GROUP_GUI_ACCESS_INTERNAL, GROUP_GUI_ACCESS_LDAP, GROUP_GUI_ACCESS_DISABLED])],
-			'users_status' =>	['type' => API_INT32, 'in' => implode(',', [GROUP_STATUS_ENABLED, GROUP_STATUS_DISABLED])],
-			'rights' =>			['type' => API_OBJECTS, 'flags' => API_NORMALIZE, 'uniq' => [['id']], 'fields' => [
-				'id' =>				['type' => API_ID, 'flags' => API_REQUIRED],
-				'permission' =>		['type' => API_INT32, 'flags' => API_REQUIRED, 'in' => implode(',', [PERM_DENY, PERM_READ, PERM_READ_WRITE])]
+			'name' =>				['type' => API_STRING_UTF8, 'flags' => API_REQUIRED | API_NOT_EMPTY, 'length' => DB::getFieldLength('usrgrp', 'name')],
+			'debug_mode' =>			['type' => API_INT32, 'in' => implode(',', [GROUP_DEBUG_MODE_DISABLED, GROUP_DEBUG_MODE_ENABLED])],
+			'gui_access' =>			['type' => API_INT32, 'in' => implode(',', [GROUP_GUI_ACCESS_SYSTEM, GROUP_GUI_ACCESS_INTERNAL, GROUP_GUI_ACCESS_LDAP, GROUP_GUI_ACCESS_DISABLED]), 'default' => DB::getDefault('usrgrp', 'gui_access')],
+			'users_status' =>		['type' => API_INT32, 'in' => implode(',', [GROUP_STATUS_ENABLED, GROUP_STATUS_DISABLED])],
+			'userdirectoryid' =>	['type' => API_MULTIPLE, 'rules' => [
+										['if' => ['field' => 'gui_access', 'in' => implode(',', [GROUP_GUI_ACCESS_SYSTEM, GROUP_GUI_ACCESS_LDAP])], 'type' => API_ID],
+										['else' => true, 'type' => API_UNEXPECTED]
 			]],
-			'tag_filters' =>	['type' => API_OBJECTS, 'uniq' => [['groupid', 'tag', 'value']], 'fields' => [
-				'groupid' =>		['type' => API_ID, 'flags' => API_REQUIRED],
-				'tag' =>			['type' => API_STRING_UTF8, 'length' => DB::getFieldLength('tag_filter', 'tag'), 'default' => DB::getDefault('tag_filter', 'tag')],
-				'value' =>			['type' => API_STRING_UTF8, 'length' => DB::getFieldLength('tag_filter', 'value'), 'default' => DB::getDefault('tag_filter', 'value')]
+			'rights' =>				['type' => API_OBJECTS, 'flags' => API_NORMALIZE, 'uniq' => [['id']], 'fields' => [
+				'id' =>					['type' => API_ID, 'flags' => API_REQUIRED],
+				'permission' =>			['type' => API_INT32, 'flags' => API_REQUIRED, 'in' => implode(',', [PERM_DENY, PERM_READ, PERM_READ_WRITE])]
 			]],
-			'userids' =>		['type' => API_IDS, 'flags' => API_NORMALIZE | API_DEPRECATED, 'uniq' => true],
-			'users' =>			['type' => API_OBJECTS, 'flags' => API_NORMALIZE, 'uniq' => [['userid']], 'fields' => [
-				'userid' =>			['type' => API_ID, 'flags' => API_REQUIRED]
+			'tag_filters' =>		['type' => API_OBJECTS, 'uniq' => [['groupid', 'tag', 'value']], 'fields' => [
+				'groupid' =>			['type' => API_ID, 'flags' => API_REQUIRED],
+				'tag' =>				['type' => API_STRING_UTF8, 'length' => DB::getFieldLength('tag_filter', 'tag'), 'default' => DB::getDefault('tag_filter', 'tag')],
+				'value' =>				['type' => API_STRING_UTF8, 'length' => DB::getFieldLength('tag_filter', 'value'), 'default' => DB::getDefault('tag_filter', 'value')]
+			]],
+			'userids' =>			['type' => API_IDS, 'flags' => API_NORMALIZE | API_DEPRECATED, 'uniq' => true],
+			'users' =>				['type' => API_OBJECTS, 'flags' => API_NORMALIZE, 'uniq' => [['userid']], 'fields' => [
+				'userid' =>				['type' => API_ID, 'flags' => API_REQUIRED]
 			]]
 		]];
 		if (!CApiInputValidator::validate($api_input_rules, $usrgrps, '/', $error)) {
@@ -247,6 +251,7 @@ class CUserGroup extends CApiService {
 		$this->checkHimself($usrgrps, __FUNCTION__);
 		$this->checkHostGroups($usrgrps);
 		$this->checkTagFilters($usrgrps);
+		self::checkUserDirectories($usrgrps);
 	}
 
 	/**
@@ -275,47 +280,57 @@ class CUserGroup extends CApiService {
 	 * @throws APIException if the input is invalid.
 	 */
 	private function validateUpdate(array &$usrgrps, array &$db_usrgrps = null) {
-		$api_input_rules = ['type' => API_OBJECTS, 'flags' => API_NOT_EMPTY | API_NORMALIZE, 'uniq' => [['usrgrpid'], ['name']], 'fields' => [
-			'usrgrpid' =>		['type' => API_ID, 'flags' => API_REQUIRED],
-			'name' =>			['type' => API_STRING_UTF8, 'flags' => API_NOT_EMPTY, 'length' => DB::getFieldLength('usrgrp', 'name')],
-			'debug_mode' =>		['type' => API_INT32, 'in' => implode(',', [GROUP_DEBUG_MODE_DISABLED, GROUP_DEBUG_MODE_ENABLED])],
-			'gui_access' =>		['type' => API_INT32, 'in' => implode(',', [GROUP_GUI_ACCESS_SYSTEM, GROUP_GUI_ACCESS_INTERNAL, GROUP_GUI_ACCESS_LDAP, GROUP_GUI_ACCESS_DISABLED])],
-			'users_status' =>	['type' => API_INT32, 'in' => implode(',', [GROUP_STATUS_ENABLED, GROUP_STATUS_DISABLED])],
-			'rights' =>			['type' => API_OBJECTS, 'flags' => API_NORMALIZE, 'uniq' => [['id']], 'fields' => [
-				'id' =>				['type' => API_ID, 'flags' => API_REQUIRED],
-				'permission' =>		['type' => API_INT32, 'flags' => API_REQUIRED, 'in' => implode(',', [PERM_DENY, PERM_READ, PERM_READ_WRITE])]
-			]],
-			'tag_filters' =>	['type' => API_OBJECTS, 'uniq' => [['groupid', 'tag', 'value']], 'fields' => [
-				'groupid' =>		['type' => API_ID, 'flags' => API_REQUIRED],
-				'tag' =>			['type' => API_STRING_UTF8, 'length' => DB::getFieldLength('tag_filter', 'tag'), 'default' => DB::getDefault('tag_filter', 'tag')],
-				'value' =>			['type' => API_STRING_UTF8, 'length' => DB::getFieldLength('tag_filter', 'value'), 'default' => DB::getDefault('tag_filter', 'value')]
-			]],
-			'userids' =>		['type' => API_IDS, 'flags' => API_NORMALIZE | API_DEPRECATED, 'uniq' => true],
-			'users' =>			['type' => API_OBJECTS, 'flags' => API_NORMALIZE, 'uniq' => [['userid']], 'fields' => [
-				'userid' =>			['type' => API_ID, 'flags' => API_REQUIRED]
-			]]
+		$api_input_rules = ['type' => API_OBJECTS, 'flags' => API_NOT_EMPTY | API_NORMALIZE | API_ALLOW_UNEXPECTED, 'uniq' => [['usrgrpid']], 'fields' => [
+			'usrgrpid' =>	['type' => API_ID, 'flags' => API_REQUIRED]
 		]];
+
 		if (!CApiInputValidator::validate($api_input_rules, $usrgrps, '/', $error)) {
 			self::exception(ZBX_API_ERROR_PARAMETERS, $error);
 		}
 
-		// Check user group names.
-		$db_usrgrps = DB::select('usrgrp', [
+		$usrgrpids = array_column($usrgrps, 'usrgrpid');
+		$db_usrgrps = API::UserGroup()->get([
 			'output' => ['usrgrpid', 'name', 'debug_mode', 'gui_access', 'users_status'],
-			'usrgrpids' => array_column($usrgrps, 'usrgrpid'),
+			'usrgrpids' => $usrgrpids,
 			'preservekeys' => true
 		]);
 
+		if (count($usrgrpids) != count($db_usrgrps)) {
+			self::exception(ZBX_API_ERROR_PERMISSIONS, _('No permissions to referred object or it does not exist!'));
+		}
+
 		$names = [];
+		$usrgrps = $this->extendObjectsByKey($usrgrps, $db_usrgrps, 'usrgrpid', ['gui_access']);
+		$api_input_rules = ['type' => API_OBJECTS, 'flags' => API_NOT_EMPTY | API_NORMALIZE, 'uniq' => [['name']], 'fields' => [
+			'usrgrpid' =>			['type' => API_ID],
+			'name' =>				['type' => API_STRING_UTF8, 'flags' => API_NOT_EMPTY, 'length' => DB::getFieldLength('usrgrp', 'name')],
+			'debug_mode' =>			['type' => API_INT32, 'in' => implode(',', [GROUP_DEBUG_MODE_DISABLED, GROUP_DEBUG_MODE_ENABLED])],
+			'gui_access' =>			['type' => API_INT32, 'in' => implode(',', [GROUP_GUI_ACCESS_SYSTEM, GROUP_GUI_ACCESS_INTERNAL, GROUP_GUI_ACCESS_LDAP, GROUP_GUI_ACCESS_DISABLED])],
+			'users_status' =>		['type' => API_INT32, 'in' => implode(',', [GROUP_STATUS_ENABLED, GROUP_STATUS_DISABLED])],
+			'userdirectoryid' =>	['type' => API_MULTIPLE, 'rules' => [
+										['if' => ['field' => 'gui_access', 'in' => implode(',', [GROUP_GUI_ACCESS_SYSTEM, GROUP_GUI_ACCESS_LDAP])], 'type' => API_ID],
+										['else' => true, 'type' => API_UNEXPECTED]
+			]],
+			'rights' =>				['type' => API_OBJECTS, 'flags' => API_NORMALIZE, 'uniq' => [['id']], 'fields' => [
+				'id' =>					['type' => API_ID, 'flags' => API_REQUIRED],
+				'permission' =>			['type' => API_INT32, 'flags' => API_REQUIRED, 'in' => implode(',', [PERM_DENY, PERM_READ, PERM_READ_WRITE])]
+			]],
+			'tag_filters' =>		['type' => API_OBJECTS, 'uniq' => [['groupid', 'tag', 'value']], 'fields' => [
+				'groupid' =>			['type' => API_ID, 'flags' => API_REQUIRED],
+				'tag' =>				['type' => API_STRING_UTF8, 'length' => DB::getFieldLength('tag_filter', 'tag'), 'default' => DB::getDefault('tag_filter', 'tag')],
+				'value' =>				['type' => API_STRING_UTF8, 'length' => DB::getFieldLength('tag_filter', 'value'), 'default' => DB::getDefault('tag_filter', 'value')]
+			]],
+			'userids' =>			['type' => API_IDS, 'flags' => API_NORMALIZE | API_DEPRECATED, 'uniq' => true],
+			'users' =>				['type' => API_OBJECTS, 'flags' => API_NORMALIZE, 'uniq' => [['userid']], 'fields' => [
+				'userid' =>				['type' => API_ID, 'flags' => API_REQUIRED]
+			]]
+		]];
 
-		foreach ($usrgrps as &$usrgrp) {
-			// Check if this user group exists.
-			if (!array_key_exists($usrgrp['usrgrpid'], $db_usrgrps)) {
-				self::exception(ZBX_API_ERROR_PERMISSIONS,
-					_('No permissions to referred object or it does not exist!')
-				);
-			}
+		if (!CApiInputValidator::validate($api_input_rules, $usrgrps, '/', $error)) {
+			self::exception(ZBX_API_ERROR_PARAMETERS, $error);
+		}
 
+		foreach ($usrgrps as &$usrgrp) {
 			if (array_key_exists('userids', $usrgrp)) {
 				if (array_key_exists('users', $usrgrp)) {
 					self::exception(ZBX_API_ERROR_PARAMETERS, _s('Parameter "%1$s" is deprecated.', 'userids'));
@@ -330,6 +345,12 @@ class CUserGroup extends CApiService {
 			if (array_key_exists('name', $usrgrp) && $usrgrp['name'] !== $db_usrgrp['name']) {
 				$names[] = $usrgrp['name'];
 			}
+
+			if (array_key_exists('gui_access', $usrgrp) && $usrgrp['gui_access'] != $db_usrgrp['gui_access']
+					&& $usrgrp['gui_access'] != GROUP_GUI_ACCESS_LDAP
+					&& $usrgrp['gui_access'] != GROUP_GUI_ACCESS_SYSTEM) {
+				$usrgrp['userdirectoryid'] = 0;
+			}
 		}
 		unset($usrgrp);
 
@@ -343,6 +364,7 @@ class CUserGroup extends CApiService {
 		$this->checkUsersWithoutGroups($usrgrps);
 		$this->checkHostGroups($usrgrps);
 		$this->checkTagFilters($usrgrps);
+		self::checkUserDirectories($usrgrps);
 	}
 
 	/**
@@ -1156,4 +1178,37 @@ class CUserGroup extends CApiService {
 			}
 		}
 	}
+
+	/**
+	 * Check if user directories exist.
+	 *
+	 * @param array  $usrgrps
+	 * @param string $usrgrps['userdirectoryid']
+	 *
+	 * @throws APIException
+	 */
+	private static function checkUserDirectories(array $usrgrps): void {
+		$userdirectoryids = array_filter(array_column($usrgrps, 'userdirectoryid'));
+
+		if (!$userdirectoryids) {
+			return;
+		}
+
+		$db_userdirectories = API::UserDirectory()->get([
+			'output' => [],
+			'userdirectoryids' => $userdirectoryids,
+			'preservekeys' => true
+		]);
+
+		foreach ($usrgrps as $i => $usrgrp) {
+			if (array_key_exists('userdirectoryid', $usrgrp) && $usrgrp['userdirectoryid'] != 0
+					&& !array_key_exists($usrgrp['userdirectoryid'], $db_userdirectories)) {
+				self::exception(ZBX_API_ERROR_PARAMETERS,
+					_s('Invalid parameter "%1$s": %2$s.', '/'.($i + 1).'/userdirectoryid',
+						_('referred object does not exist')
+					)
+				);
+			}
+		}
+	}
 }
diff --git a/ui/include/classes/helpers/CAuthenticationHelper.php b/ui/include/classes/helpers/CAuthenticationHelper.php
index 486231bb136..7a348532599 100644
--- a/ui/include/classes/helpers/CAuthenticationHelper.php
+++ b/ui/include/classes/helpers/CAuthenticationHelper.php
@@ -29,14 +29,9 @@ class CAuthenticationHelper extends CConfigGeneralHelper {
 	public const HTTP_CASE_SENSITIVE = 'http_case_sensitive';
 	public const HTTP_LOGIN_FORM = 'http_login_form';
 	public const HTTP_STRIP_DOMAINS = 'http_strip_domains';
-	public const LDAP_BASE_DN = 'ldap_base_dn';
-	public const LDAP_BIND_DN = 'ldap_bind_dn';
-	public const LDAP_BIND_PASSWORD = 'ldap_bind_password';
-	public const LDAP_CASE_SENSITIVE = 'ldap_case_sensitive';
 	public const LDAP_CONFIGURED = 'ldap_configured';
-	public const LDAP_HOST = 'ldap_host';
-	public const LDAP_PORT = 'ldap_port';
-	public const LDAP_SEARCH_ATTRIBUTE = 'ldap_search_attribute';
+	public const LDAP_USERDIRECTORYID = 'ldap_userdirectoryid';
+	public const LDAP_CASE_SENSITIVE = 'ldap_case_sensitive';
 	public const PASSWD_CHECK_RULES = 'passwd_check_rules';
 	public const PASSWD_MIN_LENGTH = 'passwd_min_length';
 	public const SAML_AUTH_ENABLED = 'saml_auth_enabled';
